OGRE-Next: Ogre::CompositorPassComputeDef Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Public Attributes | List of all members
Ogre::CompositorPassComputeDef Class Reference
Core » Effects

`#include <OgreCompositorPassComputeDef.h>`

Inheritance diagram for Ogre::CompositorPassComputeDef:
[legend]

## Classes
struct | BufferSource
struct | ComputeTextureSource

## Public Types
typedef vector< BufferSource >::type | BufferSourceVec
typedef vector< ComputeTextureSource >::type | TextureSources
Public Types inherited from Ogre::CompositorPassDef
typedef vector< UavDependency >::type | UavDependencyVec

## Public Member Functions
| CompositorPassComputeDef (CompositorNodeDef *parentNodeDef, CompositorTargetDef *parentTargetDef)
void | addTextureSource (uint32 texUnitIdx, const String &textureName)
| Indicates the pass to change the texture units to use the specified texture sources.
void | addTextureSource (uint32 texUnitIdx, const String &textureName, uint16 textureArrayIndex, uint8 mipmapLevel, PixelFormatGpu pixelFormat)
void | addUavBuffer (uint32 slotIdx, const String &bufferName, ResourceAccess::ResourceAccess access, size_t offset=0, size_t sizeBytes=0, bool allowWriteAfterWrite=false)
void | addUavSource (uint32 texUnitIdx, const String &textureName, ResourceAccess::ResourceAccess access, uint16 textureArrayIndex, uint8 mipmapLevel, PixelFormatGpu pixelFormat, bool allowWriteAfterWrite)
const BufferSourceVec & | getBufferSources () const
const TextureSources & | getTextureSources () const
const TextureSources & | getUavSources () const
Public Member Functions inherited from Ogre::CompositorPassDef
| CompositorPassDef (CompositorPassType passType, CompositorTargetDef *parentTargetDef)
virtual | ~CompositorPassDef ()
const CompositorTargetDef * | getParentTargetDef () const
uint32 | getRtIndex () const
CompositorPassType | getType () const
void | setAllClearColours (const ColourValue &clearValue)
void | setAllLoadActions (LoadAction::LoadAction loadAction)
void | setAllStoreActions (StoreAction::StoreAction storeAction)

## Public Attributes
IdString | mCameraName
IdString | mJobName
| Name of the HlmsComputeJob to run.
Public Attributes inherited from Ogre::CompositorPassDef
ColourValue | mClearColour [OGRE_MAX_MULTIPLE_RENDER_TARGETS]
float | mClearDepth
uint32 | mClearStencil
bool | mColourWrite
| When false will not really bind the RenderTarget for rendering and use a null colour buffer instead.
uint8 | mExecutionMask
IdStringVec | mExposedTextures
bool | mFlushCommandBuffers
| Whether to flush the command buffer at the end of the pass.
uint32 | mIdentifier
| Custom value in case there's a listener attached (to identify the pass)
bool | mIncludeOverlays
| TODO: Refactor OgreOverlay to remove this design atrocity.
LoadAction::LoadAction | mLoadActionColour [OGRE_MAX_MULTIPLE_RENDER_TARGETS]
LoadAction::LoadAction | mLoadActionDepth
LoadAction::LoadAction | mLoadActionStencil
uint32 | mNumInitialPasses
| Number of times to perform the pass before stopping. -1 to never stop.
uint32 | mNumViewports
String | mProfilingId
bool | mReadOnlyDepth
bool | mReadOnlyStencil
bool | mShadowMapFullViewport
| Only used if mShadowMapIdx is valid (if pass is owned by Shadow Nodes).
uint32 | mShadowMapIdx
| Shadow map index it belongs to (only filled in passes owned by Shadow Nodes)
bool | mSkipLoadStoreSemantics
| Ignore mLoadAction*‍/mStoreAction*.
StoreAction::StoreAction | mStoreActionColour [OGRE_MAX_MULTIPLE_RENDER_TARGETS]
StoreAction::StoreAction | mStoreActionDepth
StoreAction::StoreAction | mStoreActionStencil
UavDependencyVec | mUavDependencies
uint8 | mViewportModifierMask
ViewportRect | mVpRect [16]
| Viewport's region to draw.
bool | mWarnIfRtvWasFlushed
| Will issue a warning (by raising an exception) if Ogre is forced to flush the RenderTarget, which is very bad for performance on mobile, and can cause serious performance problems in Desktop if using MSAA, and also cause correctness problems (i.e.

## Member Typedef Documentation

## ◆ BufferSourceVec

typedef vector<BufferSource>::type Ogre::CompositorPassComputeDef::BufferSourceVec

## ◆ TextureSources

typedef vector<ComputeTextureSource>::type Ogre::CompositorPassComputeDef::TextureSources

## Constructor & Destructor Documentation

## ◆ CompositorPassComputeDef()

Ogre::CompositorPassComputeDef::CompositorPassComputeDef | ( | CompositorNodeDef * | parentNodeDef,
|  | CompositorTargetDef * | parentTargetDef )
| inline

References Ogre::CompositorPassDef::CompositorPassDef(), and Ogre::PASS_COMPUTE.

## Member Function Documentation

## ◆ addTextureSource() [1/2]

void Ogre::CompositorPassComputeDef::addTextureSource | ( | uint32 | texUnitIdx,
|  | const String & | textureName )

Indicates the pass to change the texture units to use the specified texture sources.

See CompositorPassComputeDef::ComputeTextureSource for params

## ◆ addTextureSource() [2/2]

void Ogre::CompositorPassComputeDef::addTextureSource | ( | uint32 | texUnitIdx,
|  | const String & | textureName,
|  | uint16 | textureArrayIndex,
|  | uint8 | mipmapLevel,
|  | PixelFormatGpu | pixelFormat )

## ◆ addUavBuffer()

void Ogre::CompositorPassComputeDef::addUavBuffer | ( | uint32 | slotIdx,
|  | const String & | bufferName,
|  | ResourceAccess::ResourceAccess | access,
|  | size_t | offset = 0,
|  | size_t | sizeBytes = 0,
|  | bool | allowWriteAfterWrite = false )

## ◆ addUavSource()

void Ogre::CompositorPassComputeDef::addUavSource | ( | uint32 | texUnitIdx,
|  | const String & | textureName,
|  | ResourceAccess::ResourceAccess | access,
|  | uint16 | textureArrayIndex,
|  | uint8 | mipmapLevel,
|  | PixelFormatGpu | pixelFormat,
|  | bool | allowWriteAfterWrite )

## ◆ getBufferSources()

const BufferSourceVec & Ogre::CompositorPassComputeDef::getBufferSources | ( |  | ) | const
| inline

## ◆ getTextureSources()

const TextureSources & Ogre::CompositorPassComputeDef::getTextureSources | ( |  | ) | const
| inline

## ◆ getUavSources()

const TextureSources & Ogre::CompositorPassComputeDef::getUavSources | ( |  | ) | const
| inline

## Member Data Documentation

## ◆ mCameraName

IdString Ogre::CompositorPassComputeDef::mCameraName

## ◆ mJobName

IdString Ogre::CompositorPassComputeDef::mJobName

Name of the HlmsComputeJob to run.

The documentation for this class was generated from the following file:

- OgreCompositorPassComputeDef.h